package com.jsowell.netty.handler;

import com.alibaba.fastjson2.JSONObject;
import com.jsowell.common.core.domain.ykc.YKCDataProtocol;
import com.jsowell.common.core.domain.ykc.YKCFrameTypeCode;
import com.jsowell.common.util.BytesUtil;
import com.jsowell.common.util.YKCUtils;
import com.jsowell.netty.factory.YKCOperateFactory;
import io.netty.channel.Channel;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

/**
 * 充电阶段 BMS 中止Handler
 *
 * GBT-27930 充电桩与 BMS 充电阶段 BMS 中止报文
 * @author JS-ZZA
 * @date 2022/9/19 13:32
 */
@Slf4j
@Component
public class BMSAbortDuringChargingPhaseHandler extends AbstractHandler{
    private final String type = YKCUtils.frameType2Str(YKCFrameTypeCode.BMS_ABORT_DURING_CHARGING_PHASE_CODE.getBytes());

    @Override
    public void afterPropertiesSet() throws Exception {
        YKCOperateFactory.register(type, this);
    }

    @Override
    public byte[] supplyProcess(YKCDataProtocol ykcDataProtocol, Channel channel) {
        log.info("[===充电阶段 BMS 中止===] param:{}, channel:{}", JSONObject.toJSONString(ykcDataProtocol), channel.toString());
        // 获取消息体
        byte[] msgBody = ykcDataProtocol.getMsgBody();

        int startIndex = 0;
        int length = 16;

        // 交易流水号
        byte[] serialNumByteArr = BytesUtil.copyBytes(msgBody, startIndex, length);
        String orderCode = BytesUtil.bcd2Str(serialNumByteArr);

        // 桩编码
        startIndex += length;
        length = 7;
        byte[] pileSnByteArr = BytesUtil.copyBytes(msgBody, startIndex, length);
        String pileSn = BytesUtil.bcd2Str(pileSnByteArr);

        // 保存时间
        saveLastTime(pileSn);

        // 枪号
        startIndex += length;
        length = 1;
        byte[] pileConnectorNumByteArr = BytesUtil.copyBytes(msgBody, startIndex, length);
        String connectorCode = BytesUtil.bcd2Str(pileConnectorNumByteArr);

        /**
         * BMS 中止充电原因
         * 1-2 位——所需求的 SOC 目标值
         * 3-4 位——达到总电压的设定值
         * 5-6 位——达到单体电压设定值
         * 7-8 位——充电机主动中止
         */
        startIndex += length;
        byte[] BMSStopReasonByteArr = BytesUtil.copyBytes(msgBody, startIndex, length);


        /**
         * BMS 中止充电故障原因
         * 1-2 位——绝缘故障
         * 3-4 位——输出连接器过温故障
         * 5-6 位——BMS 元件、输出连接 器过温
         * 7-8 位——充电连接器故障
         * 9-10 位——电池组温度过高故障
         * 11-12 位——高压继电器故障
         * 13-14 位——检测点 2 电压检测故障
         * 15-16 位——其他故障
         */
        startIndex += length;
        length = 2;
        byte[] BMSStopFaultReasonByteArr = BytesUtil.copyBytes(msgBody, startIndex, length);

        /**
         * BMS 中止充电错误原因
         * 1-2 位——电流过大
         * 3-4 位——电压异常
         * 5-8 位——预留位
         */
        startIndex += length;
        byte[] BMSStopErrorReasonByteArr = BytesUtil.copyBytes(msgBody, startIndex, length);


        return null;
    }
}
